/****************************************************************************/
/* Ώۃ}CR R8C/M12A                                                    */
/* ̧ٓe     tVA䃉Cu                                  */
/* o[W   Ver.1.01                                                    */
/* Date         2012.04.27                                                  */
/* Copyright    lTX}CRJ[[                            */
/****************************************************************************/

/*======================================*/
/* V{`                         */
/*======================================*/
#define DATA        lcd_cmd1            /* f[^ݒ肷ϐ         */

#define E_1         (DATA |=  LCD_E)
#define E_0         (DATA &= ~LCD_E)
#define RS_1        (DATA |=  LCD_RS)
#define RS_0        (DATA &= ~LCD_RS)
#define RS_DB7_1    (DATA |=  LCD_DB7)
#define RS_DB7_0    (DATA &= ~LCD_DB7)
#define RS_DB6_1    (DATA |=  LCD_DB6)
#define RS_DB6_0    (DATA &= ~LCD_DB6)
#define RS_DB5_1    (DATA |=  LCD_DB5)
#define RS_DB5_0    (DATA &= ~LCD_DB5)
#define RS_DB4_1    (DATA |=  LCD_DB4)
#define RS_DB4_0    (DATA &= ~LCD_DB4)

/*======================================*/
/* CN[h                         */
/*======================================*/
#include "sfr_r8m12a.h"                 /* R8C/M12A SFR̒`t@C   */
#include "lcd_lib_sirial.h"             /* tVA䃉Cu   */

/*======================================*/
/* O[oϐ̐錾                 */
/*======================================*/
static unsigned char lcd_cmd1;          /* VAőR}h       */

/************************************************************************/
/* VAŃf[^M                                                 */
/* @ Mf[^                                                    */
/* ߂l 0:MőMł 1:Mf[^Zbg                   */
/************************************************************************/
static int put_uart0( char r )
{
    if(ti_u0c1 == 1) {                  /* Mf[^ȂH             */
        u0tbl = r;
        return 1;
    } else {
        /* ɑM(̃f[^͑MɏI) */
        return 0;
    }
}

/************************************************************************/
/* tɃVAŃf[^M                                           */
/* @ Ȃ                                                          */
/* ߂l Ȃ                                                          */
/************************************************************************/
static void set_lcd_sirial_data( void )
{
    while( !put_uart0( DATA ) );        /* փf[^o           */
    while( !txept_u0c0 );               /* o͂I܂ő҂         */
    HC595_LCK = 1;                      /* 74HC595f[^o        */
    HC595_LCK = 0;
}

/************************************************************************/
/* 1ms̃EGCg                                                        */
/* @ [ms]                                                      */
/* ߂l Ȃ                                                          */
/************************************************************************/
static void lcd_wait( unsigned int msec )
{
    int tmp;

    while( msec > 0 ) {
        for( tmp = 0 ; tmp < 1000 ; tmp++);
        msec--;
    }
}

/************************************************************************/
/* t 4rbgM                                                     */
/* @ char bitdata : DB7`DB4ɐݒ肷f[^                       */
/* ߂l Ȃ                                                          */
/************************************************************************/
static void lcd_put_4bit( char data )
{
    int i;

    /* DB7`DB4̐ݒ */
    if( data & 0x08) RS_DB7_1; else RS_DB7_0;
    if( data & 0x04) RS_DB6_1; else RS_DB6_0;
    if( data & 0x02) RS_DB5_1; else RS_DB5_0;
    if( data & 0x01) RS_DB4_1; else RS_DB4_0;

    E_1;                                /* ENABLE = H                   */
    set_lcd_sirial_data();

    E_0;                                /* ENABLE = L                   */
    set_lcd_sirial_data();
}

/************************************************************************/
/* t 1oCgM                                                     */
/* @ char data tփf[^M                                    */
/* ߂l Ȃ                                                          */
/************************************************************************/
static void lcd_put_ch(char data)
{
    int i;

    lcd_put_4bit( data >> 4 );          /* 4rbgM              */
    lcd_put_4bit( data & 0x0f );        /* 4rbgM              */

    lcd_wait( 1 );
}

/************************************************************************/
/* t(VA)                                               */
/* @ Ȃ                                                          */
/* ߂l Ȃ                                                          */
/************************************************************************/
void lcd_sirial_init( void )
{
    /* UART0̐ݒ */
    mstuart = 0;                        /* UART0Lɂ            */
#if TXD0 == 1
    p14sel2 = 0;                        /* P1_4 = TXD0[qɂ        */
    p14sel1 = 0;
    p14sel0 = 1;
#endif
#if TXD0 == 2
    p42sel1 = 1;                        /* P4_2 = TXD0[qɂ        */
    p42sel0 = 0;
#endif
#if TXD0 == 3
    p46sel2 = 0;                        /* P4_6 = TXD0[qɂ        */
    p46sel1 = 1;
    p46sel0 = 0;
#endif

    p16sel1 = 0;                        /* P1_6 = CLK0[qɂ        */
    p16sel0 = 1;

    u0mr  = 0x11;                       /* ۯرI/OӰ        */
    u0c0  = 0x80;                       /* MSB̧ U0BRGĿ:f1     */
    u0brg = 0;                          /* f1     /(16*(u0brg+1)) =     */
                                        /* 20*10^6/(16*(0+1))=1250000pbs*/
    te_u0c1 = 1;                        /* Mrbg:M      */

    /* t */
    lcd_wait( 15 );
    RS_0;                               /* RS = L                       */
    set_lcd_sirial_data();

    lcd_put_4bit( 0x3 );                /* Function Set Mode            */
    lcd_wait(4);
    lcd_put_4bit( 0x3 );
    lcd_wait(1);
    lcd_put_4bit( 0x3 );
    lcd_put_4bit( 0x2 );                /* Function Set Mode=4bit       */

    lcd_control( 0x28 );                /* Mode=4bit,Line=2,Font=5x7dot */
    lcd_control( LCD_CURSOR_OFF );      /* or LCD_CURSOR_ON             */
    lcd_control( LCD_CURSOR_INC );
    lcd_control( LCD_CLEAR );
}

/************************************************************************/
/* t\ʒu̐ݒ                                                   */
/* @ char s(0`15), char (0`1)                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void lcd_position( char x ,char y )
{
    RS_0;                                   /* RS = L                   */
    set_lcd_sirial_data();

    lcd_put_ch(0x80 | x | (0x40 * y));      /* AhXZbg           */
}

/************************************************************************/
/* tR}h̐ݒ                                               */
/* @ char s(0`15), char (0`1)                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void lcd_control( unsigned char data )
{
    RS_0;                                   /* RS = L                   */
    set_lcd_sirial_data();

    lcd_put_ch( data );
    lcd_wait( 2 );
}

/************************************************************************/
/* tɐli10ij\                                           */
/* @ long \鐔l, int (1`8)                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void lcd_put_num( long value, int keta )
{
    long temp = 0;
    int i = keta-1;

    RS_1;                               /* RS = H                       */
    set_lcd_sirial_data();

    while( (i--) != 0 ) {
        temp += value % 10;
        value /= 10;
        temp <<= 4;
    }
    temp += (value % 10 );

    do {
        lcd_put_ch( (temp & 0xf) + '0' );  /* 1\                 */
        temp >>= 4;
    } while( --keta );
}

/************************************************************************/
/* tɐli16ij\                                           */
/* @ long \鐔l, int (1`8)                             */
/* ߂l Ȃ                                                          */
/************************************************************************/
void lcd_put_hex( long value, int keta )
{
    long temp = 0;
    int i = keta-1;
    char c;

    RS_1;                               /* RS = H                       */
    set_lcd_sirial_data();

    while( (i--) != 0 ) {
        temp += (value & 0x0f);
        value >>= 4;
        temp <<= 4;
    }
    temp += value & 0xf;

    do {
        c = temp & 0x0f;
        c += (c < 10) ? '0' : ('a'-10);
        lcd_put_ch( c );                /* 1\                    */
        temp >>= 4;
    } while( --keta );
}

/************************************************************************/
/* tɕ\                                                     */
/* @ char *str : ̐擪|C^                              */
/* ߂l Ȃ                                                          */
/************************************************************************/
void lcd_put_str( char *str )
{
    RS_1;                               /* RS = H                       */
    set_lcd_sirial_data();

    while(*str != 0) {
        lcd_put_ch( *str );             /* 1M                    */
        str++;
    }
}

/************************************************************************/
/* end of file                                                          */
/************************************************************************/

/*
o
Ver.1.00 2012.04.05 쐬
Ver.1.01 2012.04.27 lcd_put_num֐Alcd_put_hex֐̕sC
*/